Index: moodle/lib/navigationlib.php
--- moodle/lib/navigationlib.php Base (1.86)
+++ moodle/lib/navigationlib.php Locally Modified (Based On 1.86)
@@ -859,143 +737,437 @@
  * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
  */
 class global_navigation extends navigation_node {
-    /** @var int */
-    protected $depthforward = 1;
-    /** @var cache */
-    protected $cache = null;
+    /**
+     * The Moodle page this navigation object belongs to.
+     * @var moodle_page
+     */
+    protected $page;
     /** @var bool */
     protected $initialised = false;
-
-    /** @var null|int */
-    public $expansionlimit = null;
-    /** @var stdClass */
-    public $context = null;
-    /** @var mixed */
-    public $expandable = null;
+    /** @var array */
+    protected $mycourses = array();
+    /** @var array */
+    protected $rootnodes = array();
     /** @var bool */
-    public $showemptybranches = true;
-    /** @var bool  */
-    protected $isloggedin = false;
-    /** @var array Array of user objects to extend the navigation with */
+    protected $showemptysections = false;
+    /** @var array */
     protected $extendforuser = array();
-    /** @var bool Gets set to true if all categories have been loaded */
-    protected $allcategoriesloaded = false;
-
+    /** @var navigation_cache */
+    protected $cache;
+    /** @var array */
+    protected $addedcourses = array();
     /**
-     * Sets up the object with basic settings and preparse it for use
+     * Constructs a new global navigation
+     *
+     * @global stdClass $SITE
+     * @global stdClass $USER
+     * @param moodle_page $page The page this navigation object belongs to
      */
-    public function __construct() {
-        global $CFG;
+    public function __construct(moodle_page $page) {
+        global $SITE, $USER;
+
         if (during_initial_install()) {
-            return false;
+            return;
         }
-        $this->key = 0;
-        $this->type = self::TYPE_SYSTEM;
-        $this->isloggedin = isloggedin();
-        $this->text = get_string('home');
+
+        // Use the parents consturctor.... good good reuse
+        $properties = array(
+            'key' => 'home',
+            'type' => navigation_node::TYPE_SYSTEM,
+            'text' => get_string('home'),
+            'action' => new moodle_url('/my/')
+        );
+        parent::__construct($properties);
+
+        // Initalise and set defaults
+        $this->page = $page;
         $this->forceopen = true;
-        $this->action = new moodle_url($CFG->wwwroot);
         $this->cache = new navigation_cache(NAVIGATION_CACHE_NAME);
+
+        // Check if we need to clear the cache
         $regenerate = optional_param('regenerate', null, PARAM_TEXT);
-        if ($regenerate==='navigation') {
+        if ($regenerate === 'navigation') {
             $this->cache->clear();
         }
     }
 
     /**
-     * Override: This function generated the content of the navigation
+     * Initialises the navigation object.
      *
-     * If an expansion limit has been set then we hide everything to after that
-     * set limit type
+     * This causes the navigation object to look at the current state of the page
+     * that it is associated with and then load the appropriate content.
      *
-     * @return string
-     */
-    public function content() {
-        if ($this->expansionlimit!==null) {
-            $this->toggle_type_display($this->expansionlimit);
-        }
-        return parent::content();
-    }
-
-    /**
-     * Initialise the navigation object, calling it to auto generate
+     * This should only occur the first time that the navigation structure is utilised
+     * which will normally be either when the navbar is called to be displayed or
+     * when a block makes use of it.
      *
-     * This function starts the navigation object automatically retrieving what it
-     * needs from Moodle objects.
-     *
-     * It also passed Javascript args and function calls as required
-     *
-     * @return bool Returns true
+     * @global stdClass $SITE
+     * @global stdClass $USER
+     * @return bool
      */
-    public function initialise($jsargs = null) {
-        global $PAGE, $SITE, $USER;
+    public function initialise() {
+        global $SITE, $USER;
+        // Check if it has alread been initialised
         if ($this->initialised || during_initial_install()) {
             return true;
         }
-        $start = microtime(false);
-        $this->depthforward = 1;
-        $this->context = $PAGE->context;
-        $contextlevel = $this->context->contextlevel;
-        if ($contextlevel == CONTEXT_COURSE && $PAGE->course->id==$SITE->id) {
-            $contextlevel = 10;
+
+        // Set up the five base root nodes. These are nodes where we will put our
+        // content and are as follows:
+        // site:        Navigation for the front page.
+        // profile:     User profile information goes here.
+        // mycourses:   The users courses get added here.
+        // courses:     Additional courses are added here.
+        // users:       Other users information loaded here.
+        $this->rootnodes = array();
+        $this->rootnodes['site']      = $this->add_course($SITE);
+        $this->rootnodes['profile']   = $this->add(get_string('profile'), null, self::TYPE_USER, null, 'profile');
+        $this->rootnodes['mycourses'] = $this->add(get_string('mycourses'), null, self::TYPE_ROOTNODE, null, 'mycourses');
+        $this->rootnodes['courses']   = $this->add(get_string('courses'), null, self::TYPE_ROOTNODE, null, 'courses');
+        $this->rootnodes['users']     = $this->add(get_string('users'), null, self::TYPE_ROOTNODE, null, 'users');
+
+        // Fetch all of the users courses.
+        $this->mycourses = get_my_courses($USER->id);
+        // Check if any courses were returned.
+        if (count($this->mycourses) > 0) {
+            // Add all of the users courses to the navigation
+            foreach ($this->mycourses as &$course) {
+              $course->coursenode = $this->add_course($course);
         }
-        $depth = 0;
+        } else {
+            // The user had no specific courses! they could be no logged in, guest
+            // or admin so load all courses instead.
+            $this->load_all_courses();
+        }
 
-        /**
-         * We always want to load the front page activities into the tree, these
-         * will appear at the bottom of the opening (site) node.
-         */
-        $sitekeys = array();
-        $this->load_course_activities($sitekeys, $SITE);
-        $this->load_section_activities($sitekeys, false, $SITE);
-        switch ($contextlevel) {
-            case CONTEXT_SYSTEM:
-                $this->cache->volatile();
-                $depth = $this->load_for_category(false);
+        // Next load context specific content into the navigation
+        switch ($this->page->context->contextlevel) {
+            case CONTEXT_SYSTEM :
+            case CONTEXT_COURSECAT :
+                // Load the front page course navigation
+                $this->load_course($SITE);
                 break;
-            case CONTEXT_COURSECAT:
-                $depth = $this->load_for_category();
+            case CONTEXT_BLOCK :
+            case CONTEXT_COURSE :
+                // Load the course associated with the page into the navigation
+                $course = $this->page->course;
+                $coursenode = $this->load_course($course);
+                // Make it active
+                $coursenode->make_active();
+                // Add the essentials such as reports etc...
+                $this->add_course_essentials($coursenode, $course);
+                if ($this->format_display_course_content($course->format)) {
+                    // Load the course sections
+                    $sections = $this->load_course_sections($course, $coursenode);
+                }
                 break;
-            case CONTEXT_BLOCK:
-            case CONTEXT_COURSE:
-                $depth = $this->load_for_course();
+            case CONTEXT_MODULE :
+                $course = $this->page->course;
+                $cm = $this->page->cm;
+                // Load the course associated with the page into the navigation
+                $coursenode = $this->load_course($course);
+                $this->add_course_essentials($coursenode, $course);
+                // Load the course sections into the page
+                $sections = $this->load_course_sections($course, $coursenode);
+                if ($course->id !== SITEID) {
+                    // Find the section for the $CM associated with the page and collect
+                    // its section number.
+                    foreach ($sections as $section) {
+                        if ($section->id == $cm->section) {
+                            $cm->sectionnumber = $section->section;
                 break;
-            case CONTEXT_MODULE:
-                $depth = $this->load_for_activity();
+                        }
+                    }
+
+                    // Load all of the section activities for the section the cm belongs to.
+                    $activities = $this->load_section_activities($sections[$cm->sectionnumber]->sectionnode, $cm->sectionnumber, get_fast_modinfo($course));
+                    // Finally load the cm specific navigaton information
+                } else {
+                    $activities = array();
+                    $activities[$cm->id] = $coursenode->get($cm->id, navigation_node::TYPE_ACTIVITY);
+                }
+                $this->load_activity($cm, $course, $activities[$cm->id]);
+                // And make the activity node active.
+                $activities[$cm->id]->make_active();
                 break;
-            case CONTEXT_USER:
-                // If the PAGE course is not the site then add the content of the
-                // course
-                if ($PAGE->course->id !== SITEID) {
-                    $depth = $this->load_for_course();
+            case CONTEXT_USER :
+                $course = $this->page->course;
+                if ($course->id != SITEID) {
+                    // Load the course associated with the user into the navigation
+                    $coursenode = $this->load_course($course);
+                    $this->add_course_essentials($coursenode, $course);
+                    $sections = $this->load_course_sections($course, $coursenode);
                 }
                 break;
         }
 
+        // Load for the current user
+        $this->load_for_user();
         // Load each extending user into the navigation.
         foreach ($this->extendforuser as $user) {
             if ($user->id !== $USER->id) {
                 $this->load_for_user($user);
             }
         }
-        // Load the current user into the the navigation
-        $this->load_for_user();
 
-        $this->collapse_at_depth($this->depthforward+$depth);
-        $this->respect_forced_open();
-        $this->expandable = array();
-        $this->find_expandable($this->expandable);
+        // Remove any empty root nodes
+        foreach ($this->rootnodes as $node) {
+            if (!$node->has_children()) {
+                $node->remove();
+            }
+        }
+
+        // If the user is not logged in modify the navigation structure as detailed
+        // in {@link http://docs.moodle.org/en/Development:Navigation_2.0_structure}
+        if (!isloggedin()) {
+            $activities = clone($this->rootnodes['site']->children);
+            $this->rootnodes['site']->remove();
+            $children = clone($this->children);
+            $this->children = new navigation_node_collection();
+            foreach ($activities as $child) {
+                $this->children->add($child);
+            }
+            foreach ($children as $child) {
+                $this->children->add($child);
+            }
+            $this->action = new moodle_url('/');
+        }
+
         $this->initialised = true;
         return true;
     }
     /**
-     * This function loads the global navigation structure for a user.
+     * Checks the course format to see whether it wants the navigation to load
+     * additional information for the course.
      *
-     * This gets called by {@link initialise()} when the context is CONTEXT_USER
-     * @param object|int|null $user
+     * This function utilises a callback that can exist within the course format lib.php file
+     * The callback should be a function called:
+     * callback_{formatname}_display_content()
+     * It doesn't get any arguments and should return true if additional content is
+     * desired. If the callback doesn't exist we assume additional content is wanted.
+     *
+     * @global stdClass $CFG
+     * @param string $format The course format
+     * @return bool
      */
+    protected function format_display_course_content($format) {
+        global $CFG;
+        $formatlib = $CFG->dirroot.'/course/format/'.$format.'/lib.php';
+        if (file_exists($formatlib)) {
+            require_once($formatlib);
+            $displayfunc = 'callback_'.$format.'_display_content';
+            if (function_exists($displayfunc) && !$displayfunc()) {
+                return $displayfunc();
+            }
+        }
+        return true;
+    }
+
+    /**
+     * Loads of the the courses in Moodle into the navigation.
+     *
+     * @global moodle_database $DB
+     * @global stdClass $USER
+     * @return array An array of navigation_node
+     */
+    protected function load_all_courses() {
+        global $DB, $USER;
+        list($ccselect, $ccjoin) = context_instance_preload_sql('c.id', CONTEXT_COURSE, 'ctx');
+        $sql = "SELECT c.id,c.sortorder,c.visible,c.fullname,c.shortname,c.category,cat.path AS categorypath $ccselect
+                FROM {course} c
+                $ccjoin
+                LEFT JOIN {course_categories} cat ON cat.id=c.category
+                WHERE c.id != :siteid
+                ORDER BY c.sortorder ASC";
+        $courses = $DB->get_records_sql($sql, array('siteid'=>SITEID));
+        $coursenodes = array();
+        foreach ($courses as $course) {
+            context_instance_preload($course);
+            $coursenodes[$course->id] = $this->add_course($course);
+        }
+        return $coursenodes;
+    }
+
+    /**
+     * Loads the given course into the navigation
+     *
+     * @param stdClass $course
+     * @return navigation_node
+     */
+    protected function load_course(stdClass $course) {
+        if ($course->id == SITEID) {
+            $coursenode = $this->rootnodes['site'];
+        } else if (array_key_exists($course->id, $this->mycourses)) {
+            if (!isset($this->mycourses[$course->id]->coursenode)) {
+                $this->mycourses[$course->id]->coursenode = $this->add_course($course);
+            }
+            $coursenode = $this->mycourses[$course->id]->coursenode;
+        } else {
+            $coursenode = $this->add_course($course);
+        }
+        return $coursenode;
+    }
+
+    /**
+     * Loads all of the courses section into the navigation.
+     *
+     * This function utilisies a callback that can be implemented within the course
+     * formats lib.php file to customise the navigation that is generated at this
+     * point for the course.
+     *
+     * By default (if not defined) the method {@see load_generic_course_sections} is
+     * called instead.
+     *
+     * @global stdClass $CFG
+     * @param stdClass $course Database record for the course
+     * @param navigation_node $coursenode The course node within the navigation
+     * @return array Array of navigation nodes for the section with key = section id
+     */
+    protected function load_course_sections(stdClass $course, navigation_node $coursenode) {
+        global $CFG;
+        $structurefile = $CFG->dirroot.'/course/format/'.$course->format.'/lib.php';
+        $structurefunc = 'callback_'.$course->format.'_load_content';
+        if (function_exists($structurefunc)) {
+            return $structurefunc($this, $course, $coursenode);
+        } else if (file_exists($structurefile)) {
+            require_once $structurefile;
+            if (function_exists($structurefunc)) {
+                return $structurefunc($this, $course, $coursenode);
+            } else {
+                return $this->load_generic_course_sections($course, $coursenode, get_string('topic'), 'topic');
+            }
+        } else {
+            return $this->load_generic_course_sections($course, $coursenode, get_string('topic'), 'topic');
+        }
+    }
+
+    /**
+     * Generically loads the course sections into the course's navigation.
+     *
+     * @param stdClass $course
+     * @param navigation_node $coursenode
+     * @param string $name The string that identifies each section. e.g Topic, or Week
+     * @param string $activeparam The url used to identify the active section
+     * @return array An array of course section nodes
+     */
+    public function load_generic_course_sections(stdClass $course, navigation_node $coursenode, $name, $activeparam) {
+        $modinfo = get_fast_modinfo($course);
+        $sections = array_slice(get_all_sections($course->id), 0, $course->numsections+1, true);
+        $viewhiddensections = has_capability('moodle/course:viewhiddensections', $this->page->context);
+
+        $strgeneral = get_string('general');
+        foreach ($sections as &$section) {
+            if ($course->id == SITEID) {
+                $this->load_section_activities($coursenode, $section->section, $modinfo);
+            } else {
+                if ((!$viewhiddensections && !$section->visible) || (!$this->showemptysections && !array_key_exists($section->section, $modinfo->sections))) {
+                    continue;
+                }
+                if ($section->section == 0) {
+                    $sectionname = $strgeneral;
+                } else {
+                    $sectionname = $name.' '.$section->section;
+                }
+                $url = new moodle_url('/course/view.php', array('id'=>$course->id, $activeparam=>$section->section));
+                $sectionnode = $coursenode->add($sectionname, $url, navigation_node::TYPE_SECTION, null, $section->id);
+                $sectionnode->nodetype = navigation_node::NODETYPE_BRANCH;
+                $sectionnode->hidden = (!$section->visible);
+                if ($sectionnode->isactive) {
+                    $this->load_section_activities($sectionnode, $section->section, $modinfo);
+                }
+                $section->sectionnode = $sectionnode;
+            }
+        }
+        return $sections;
+    }
+    /**
+     * Loads all of the activities for a section into the navigation structure.
+     *
+     * @param navigation_node $sectionnode
+     * @param int $sectionnumber
+     * @param stdClass $modinfo Object returned from {@see get_fast_modinfo()}
+     * @return array Array of activity nodes
+     */
+    protected function load_section_activities(navigation_node $sectionnode, $sectionnumber, $modinfo) {
+        if (!array_key_exists($sectionnumber, $modinfo->sections)) {
+            return true;
+        }
+
+        $viewhiddenactivities = has_capability('moodle/course:viewhiddenactivities', $this->page->context);
+
+        $activities = array();
+
+        foreach ($modinfo->sections[$sectionnumber] as $cmid) {
+            $cm = $modinfo->cms[$cmid];
+            if (!$viewhiddenactivities && !$cm->visible) {
+                continue;
+            }
+            if ($cm->icon) {
+                $icon = new pix_icon($cm->icon, '', $cm->iconcomponent);
+            } else {
+                $icon = new pix_icon('icon', '', $cm->modname);
+            }
+            $url = new moodle_url('/mod/'.$cm->modname.'/view.php', array('id'=>$cm->id));
+            $activitynode = $sectionnode->add($cm->name, $url, navigation_node::TYPE_ACTIVITY, $cm->name, $cm->id, $icon);
+            $activitynode->title(get_string('modulename', $cm->modname));
+            $activitynode->hidden = (!$cm->visible);
+            if ($this->module_extends_navigation($cm->modname)) {
+                $child->nodetype = navigation_node::NODETYPE_BRANCH;
+            }
+            $activities[$cmid] = $activitynode;
+        }
+
+        return $activities;
+    }
+    /**
+     * Loads the navigation structure for the given activity into the activities node.
+     *
+     * This method utilises a callback within the modules lib.php file to load the
+     * content specific to activity given.
+     *
+     * The callback is a method: {modulename}_extend_navigation()
+     * Examples:
+     *  * {@see forum_extend_navigation()}
+     *  * {@see workshop_extend_navigation()}
+     *
+     * @global stdClass $CFG
+     * @global moodle_database $DB
+     * @param stdClass $cm
+     * @param stdClass $course
+     * @param navigation_node $activity
+     * @return bool
+     */
+    protected function load_activity(stdClass $cm, stdClass $course, navigation_node $activity) {
+        global $CFG, $DB;
+
+        $activity->make_active();
+        $file = $CFG->dirroot.'/mod/'.$cm->modname.'/lib.php';
+        $function = $cm->modname.'_extend_navigation';
+
+        if (file_exists($file)) {
+            require_once($file);
+            if (function_exists($function)) {
+                $activtyrecord = $DB->get_record($cm->modname, array('id' => $cm->instance), '*', MUST_EXIST);
+                $function($activity, $course, $activtyrecord, $cm);
+                return true;
+            }
+        }
+        $activity->nodetype = navigation_node::NODETYPE_LEAF;
+        return false;
+    }
+    /**
+     * Loads user specific information into the navigation in the appopriate place.
+     *
+     * If no user is provided the current user is assumed.
+     *
+     * @global moodle_database $DB
+     * @global stdClass $CFG
+     * @global stdClass $USER
+     * @param stdClass $user
+     * @return bool
+     */
     protected function load_for_user($user=null) {
-        global $DB, $PAGE, $CFG, $USER;
+        global $DB, $CFG, $USER;
 
         $iscurrentuser = false;
         if ($user === null) {
@@ -1010,57 +1182,50 @@
             // If the user is not an object then get them from the database
             $user = $DB->get_record('user', array('id'=>(int)$user), '*', MUST_EXIST);
         }
-        $baseargs = array('id'=>$user->id);
         $usercontext = get_context_instance(CONTEXT_USER, $user->id);
 
         // Get the course set against the page, by default this will be the site
-        $course = $PAGE->course;
+        $course = $this->page->course;
+        $baseargs = array('id'=>$user->id);
         if ($course->id !== SITEID) {
-            // Load all categories if required.
-            if (!empty($CFG->navshowallcourses)) {
-                $this->load_categories();
+            if (array_key_exists($course->id, $this->mycourses)) {
+                $coursenode = $this->mycourses[$course->id]->coursenode;
+            } else {
+                $coursenode = $this->rootnodes['courses']->find($course->id, navigation_node::TYPE_COURSE);
+                if (!$coursenode) {
+                    $coursenode = $this->load_course($course);
             }
-            // Attempt to find the course node within the navigation structure.
-            $coursetab = $this->find_child($course->id, self::TYPE_COURSE);
-            if (!$coursetab) {
-                // Load for the course.... this should never happen but is here to
-                // ensure if it ever does things don't break.
-                $this->load_for_course();
-                $coursetab = $this->find_child($course->id, self::TYPE_COURSE);
             }
-            // Get the context for the course
-            $coursecontext = get_context_instance(CONTEXT_COURSE, $course->id);
             $baseargs['course'] = $course->id;
+            $coursecontext = get_context_instance(CONTEXT_COURSE, $course->id);
             $issitecourse = false;
         } else {
             // Load all categories and get the context for the system
-            $this->load_categories();
             $coursecontext = get_context_instance(CONTEXT_SYSTEM);
             $issitecourse = true;
         }
 
         // Create a node to add user information under.
         if ($iscurrentuser) {
-            // If it's the current user the information will go under the my moodle dashboard node
-            $usernode = $this->add(get_string('mymoodledashboard'), null, navigation_node::TYPE_CUSTOM, get_string('mymoodledashboard'), 'mymoodle');
-            $usernode = $this->get($usernode);
+            // If it's the current user the information will go under the profile root node
+            $usernode = $this->rootnodes['profile'];
         } else {
             if (!$issitecourse) {
                 // Not the current user so add it to the participants node for the current course
-                $usersnode = $coursetab->find_child('participants', self::TYPE_SETTING);
+                $usersnode = $coursenode->get('participants', navigation_node::TYPE_CONTAINER);
             } else {
                 // This is the site so add a users node to the root branch
-                $usersnode = $this->find_child('users', self::TYPE_CUSTOM);
-                if (!$usersnode) {
-                    $usersnode = $this->add(get_string('users'), new moodle_url('/user/index.php', array('id'=>SITEID)), self::TYPE_CUSTOM, null, 'users');
-                    $usersnode = $this->get($usersnode);
+                $usersnode = $this->rootnodes['users'];
+                $usersnode->action = new moodle_url('/user/index.php', array('id'=>$course->id));
                 }
-            }
             // Add a branch for the current user
             $usernode = $usersnode->add(fullname($user, true));
-            $usernode = $usersnode->get($usernode);
         }
 
+        if ($this->page->context->contextlevel == CONTEXT_USER && $user->id == $this->page->context->instanceid) {
+            $usernode->force_open();
+        }
+
         // If the user is the current user or has permission to view the details of the requested
         // user than add a view profile link.
         if ($iscurrentuser || has_capability('moodle/user:viewdetails', $coursecontext) || has_capability('moodle/user:viewdetails', $usercontext)) {
@@ -1072,7 +1237,6 @@
         $canviewdiscussions = has_capability('mod/forum:viewdiscussion', $coursecontext);
         if ($canviewposts || $canviewdiscussions) {
             $forumtab = $usernode->add(get_string('forumposts', 'forum'));
-            $forumtab = $usernode->get($forumtab);
             if ($canviewposts) {
                 $forumtab->add(get_string('posts', 'forum'), new moodle_url('/mod/forum/user.php', $baseargs));
             }
@@ -1083,12 +1247,15 @@
 
         // Add a node to view the users notes if permitted
         if (!empty($CFG->enablenotes) && has_any_capability(array('moodle/notes:manage', 'moodle/notes:view'), $coursecontext)) {
-            $usernode->add(get_string('notes', 'notes'), new moodle_url('/notes/index.php',array('user'=>$user->id, 'course'=>$coursecontext->instanceid)));
+            $url = new moodle_url('/notes/index.php',array('user'=>$user->id));
+            if ($coursecontext->instanceid) {
+                $url->param('course', $coursecontext->instanceid);
         }
+            $usernode->add(get_string('notes', 'notes'), $url);
+        }
 
         // Add a reports tab and then add reports the the user has permission to see.
         $reporttab = $usernode->add(get_string('activityreports'));
-        $reporttab = $usernode->get($reporttab);
         $anyreport  = has_capability('moodle/user:viewuseractivitiesreport', $usercontext);
         $viewreports = ($anyreport || ($course->showreports && $iscurrentuser));
         $reportargs = array('user'=>$user->id);
